/*

Fish Tank Lighting Code and Auto Refill Code

Written By Ryan Ogilvie
1/20/25


 */
#include <SPI.h>
#include <WiFi101.h>
#include <TimeLib.h>


//Schedule:
bool one[] =    {0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0}; //blue
bool two[] =    {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0}; //blue
bool three[] =  {0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0}; //blank
bool four[] =   {0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0}; //double white
bool five[] =   {0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0}; //white
bool six[] =    {0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0}; //UV
//bool seven[] =  {0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0}; //refill solenoid
bool eight[] =  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; //nc


int pinMap[] = {20,21,5,6,9,10,11,12};

char ssid[] = "username";        // your network SSID (name)
char pass[] = "password";    // your network password (use for WPA, or use as key for WEP)
int status = WL_IDLE_STATUS;     // the WiFi radio's status
unsigned int long epoch;
unsigned int TIME_ZONE = -5;
int wifiUpdate = 0;
int manualState = 0;
int lastButtonState = 0;
int hour1 = 0;
int minute1 = 0;


void setup() {
  Serial.println("Beginning Startup: Fish Tank Code");
  WiFi.setPins(8,7,4,2);
  //Initialize serial and wait for port to open:
  Serial.begin(9600);
  pinMode(pinMap[0],OUTPUT);
  pinMode(pinMap[1],OUTPUT);
  pinMode(pinMap[2],OUTPUT);
  pinMode(pinMap[3],OUTPUT);
  pinMode(pinMap[4],OUTPUT);
  pinMode(pinMap[5],OUTPUT);
  pinMode(pinMap[6],OUTPUT);
  pinMode(pinMap[7],OUTPUT);
  pinMode(0,INPUT);
  pinMode(1,INPUT);
  digitalWrite(pinMap[0],1);
  digitalWrite(pinMap[1],1);
  digitalWrite(pinMap[2],1);
  digitalWrite(pinMap[3],1);
  digitalWrite(pinMap[4],1);
  digitalWrite(pinMap[5],1);
  digitalWrite(pinMap[6],1);
  digitalWrite(pinMap[7],1);

  //parse through list
  digitalWrite(pinMap[0],0);
  delay(1000);
  digitalWrite(pinMap[0],1);
  digitalWrite(pinMap[1],0);
  delay(1000);
  digitalWrite(pinMap[1],1);
  digitalWrite(pinMap[2],0);
  delay(1000);
  digitalWrite(pinMap[2],1);
  digitalWrite(pinMap[3],0);
  delay(1000);
  digitalWrite(pinMap[3],1);
  digitalWrite(pinMap[4],0);
  delay(1000);
  digitalWrite(pinMap[4],1);
  digitalWrite(pinMap[5],0);
  delay(1000);
  digitalWrite(pinMap[5],1);
  digitalWrite(pinMap[6],0);
  delay(1000);
  digitalWrite(pinMap[6],1);
  digitalWrite(pinMap[7],0);
  delay(1000);
  digitalWrite(pinMap[7],1);
  //while (!Serial) {
  //  ; // wait for serial port to connect. Needed for native USB port only
  //}

  // check for the presence of the shield:
  if (WiFi.status() == WL_NO_SHIELD) {
    Serial.println("WiFi shield not present");
    // don't continue:
    while (true);
  }
}

void loop() {
  
  delay(1);
  // check the network connection once every 2 seconds:
  if (wifiUpdate == 0){
    if ( status != WL_CONNECTED) {
      Serial.print("Attempting to connect to WPA SSID: ");
      Serial.println(ssid);
      // Connect to WPA/WPA2 network:
      status = WiFi.begin(ssid, pass);
      if ( status == WL_CONNECTED) {
        // you're connected now, so print out the data:
        Serial.print("You're connected to the network");
        printCurrentNet();
        printWiFiData();
        wifiUpdate = 1000;
        timeUpdate();
      }
    }
    else{
      wifiUpdate = 1000;
      timeUpdate();
    }
    
  }
  wifiUpdate = wifiUpdate - 1;

  if(digitalRead(0) == 1){//manual Mode
    //Serial.println(digitalRead(1));
    if(lastButtonState == 0){
      if(digitalRead(1)==1){//on press change state

        if(manualState == 4){
          manualState = 0;
        }
        else{
          manualState = manualState + 1;
        }
        Serial.println("Manual State: " + String(manualState));
      }
    }
    lastButtonState = digitalRead(1);
    
    if(manualState == 0){
      digitalWrite(pinMap[0],0);
      digitalWrite(pinMap[1],0);
      digitalWrite(pinMap[2],0);
      digitalWrite(pinMap[3],0);
      digitalWrite(pinMap[4],0);
      digitalWrite(pinMap[5],0);
      digitalWrite(pinMap[6],1);
      digitalWrite(pinMap[7],1);
    }
    else if(manualState == 1){
      digitalWrite(pinMap[0],0);
      digitalWrite(pinMap[1],1);
      digitalWrite(pinMap[2],1);
      digitalWrite(pinMap[3],1);
      digitalWrite(pinMap[4],1);
      digitalWrite(pinMap[5],1);
      digitalWrite(pinMap[6],1);
      digitalWrite(pinMap[7],1);
    }
    else if(manualState == 2){
      digitalWrite(pinMap[0],0);
      digitalWrite(pinMap[1],0);
      digitalWrite(pinMap[2],1);
      digitalWrite(pinMap[3],1);
      digitalWrite(pinMap[4],1);
      digitalWrite(pinMap[5],1);
      digitalWrite(pinMap[6],1);
      digitalWrite(pinMap[7],1);
    }
    else if(manualState == 3){//refill mode
      digitalWrite(pinMap[0],1);
      digitalWrite(pinMap[1],1);
      digitalWrite(pinMap[2],1);
      digitalWrite(pinMap[3],1);
      digitalWrite(pinMap[4],1);
      digitalWrite(pinMap[5],1);
      digitalWrite(pinMap[6],0);
      digitalWrite(pinMap[7],1);
    }
    else if(manualState == 4){//refill mode & all lights on
      digitalWrite(pinMap[0],0);
      digitalWrite(pinMap[1],0);
      digitalWrite(pinMap[2],0);
      digitalWrite(pinMap[3],0);
      digitalWrite(pinMap[4],0);
      digitalWrite(pinMap[5],0);
      digitalWrite(pinMap[6],0);
      digitalWrite(pinMap[7],0);
    }
  }
  else{//Auto Mode
    //printCurrentNet();
    //Serial.println(String(month(epoch))  + "/" + String(day(epoch)) + "/" + String(year(epoch)) + " " + String(hour(epoch)) + ":" + String(minute(epoch)) + ":" + String(second(epoch)));
    digitalWrite(pinMap[0],!one[hour1]);
    digitalWrite(pinMap[1],!two[hour1]);
    digitalWrite(pinMap[2],!three[hour1]);
    digitalWrite(pinMap[3],!four[hour1]);
    digitalWrite(pinMap[4],!five[hour1]);
    digitalWrite(pinMap[5],!six[hour1]);
    //digitalWrite(pinMap[6],!seven[hour1]);
    //digitalWrite(pinMap[7],!eight[hour1]);

    //refill tank for 30 minutes max once/day at noon
    if(hour1 == 12 && minute1 < 30){
      digitalWrite(pinMap[6],0);
    }
    else{
      digitalWrite(pinMap[6],1);
    }
  }
}
void timeUpdate(){
  epoch = WiFi.getTime();
  Serial.println("Epoch: " + String(epoch));
  Serial.println(String(month(epoch))  + "/" + String(day(epoch)) + "/" + String(year(epoch)) + " " + String(hour(epoch)) + ":" + String(minute(epoch)) + ":" + String(second(epoch)));
  epoch = epoch+TIME_ZONE*3600;
  hour1 = hour(epoch);
  minute1 = minute(epoch);
}
void printWiFiData() {
  // print your WiFi shield's IP address:
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);
  Serial.println(ip);

  // print your MAC address:
  byte mac[6];
  WiFi.macAddress(mac);
  Serial.print("MAC address: ");
  Serial.print(mac[5], HEX);
  Serial.print(":");
  Serial.print(mac[4], HEX);
  Serial.print(":");
  Serial.print(mac[3], HEX);
  Serial.print(":");
  Serial.print(mac[2], HEX);
  Serial.print(":");
  Serial.print(mac[1], HEX);
  Serial.print(":");
  Serial.println(mac[0], HEX);

}

void printCurrentNet() {
  // print the SSID of the network you're attached to:
  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());
  epoch = WiFi.getTime();
  Serial.println("Epoch: " + String(epoch));
  epoch = epoch+TIME_ZONE*3600;
  Serial.println(String(month(epoch))  + "/" + String(day(epoch)) + "/" + String(year(epoch)) + " " + String(hour(epoch)) + ":" + String(minute(epoch)) + ":" + String(second(epoch)));
  
  //Serial.println("Year: " + String(year(epoch)) + " Month: " + String(month(epoch)));

  //8/2/2022 12:27:22 AM
  //printTime();
  //time.setTime(WiFi.getTime());
  //Serial.println(hour());

  // print the MAC address of the router you're attached to:
  byte bssid[6];
  WiFi.BSSID(bssid);
  Serial.print("BSSID: ");
  Serial.print(bssid[5], HEX);
  Serial.print(":");
  Serial.print(bssid[4], HEX);
  Serial.print(":");
  Serial.print(bssid[3], HEX);
  Serial.print(":");
  Serial.print(bssid[2], HEX);
  Serial.print(":");
  Serial.print(bssid[1], HEX);
  Serial.print(":");
  Serial.println(bssid[0], HEX);

  // print the received signal strength:
  long rssi = WiFi.RSSI();
  Serial.print("signal strength (RSSI):");
  Serial.println(rssi);

  // print the encryption type:
  byte encryption = WiFi.encryptionType();
  Serial.print("Encryption Type:");
  Serial.println(encryption, HEX);
  Serial.println();
}
/*void printTime(){

    Serial.print("The UTC time is ");       // UTC is the time at Greenwich Meridian (GMT)
    Serial.print((epoch  % 86400L) / 3600); // print the hour (86400 equals secs per day)
    Serial.print(':');
    if ( ((epoch % 3600) / 60) < 10 ) {
      // In the first 10 minutes of each hour, we'll want a leading '0'
      Serial.print('0');
    }
    Serial.print((epoch  % 3600) / 60); // print the minute (3600 equals secs per minute)
    Serial.print(':');
    if ( (epoch % 60) < 10 ) {
      // In the first 10 seconds of each minute, we'll want a leading '0'
      Serial.print('0');
    }
    Serial.println(epoch % 60); // print the second
}
*/
